/*@lineinfo:filename=ResultSetFromIterator*//*@lineinfo:user-code*//*@lineinfo:1^1*///Exemple d'utilisation d'un itrateur de rsultat d'un SELECT avec SQLJ
package ExemplesSQLJ;

import sqlj.runtime.*;
import sqlj.runtime.ref.*;
import java.sql.*;

public class ResultSetFromIterator{
    public static void main (String args [])
       throws SQLException, ClassNotFoundException, java.io.IOException
  {
    // Charger le pilote JDBC d'Oracle
    Class.forName ("oracle.jdbc.driver.OracleDriver");

    // Cration du contexte de connexion de dfaut avec autocommit (true)
    DefaultContext unContext = new DefaultContext
          ("jdbc:oracle:thin:@localhost:1521:orcl", "godin", "oracle", true);
    DefaultContext.setDefaultContext(unContext);

    // Dfinition de la classe IteratorClient avec liaison par nom
    /*@lineinfo:generated-code*//*@lineinfo:21^5*/

//  ************************************************************
//  SQLJ iterator declaration:
//  ************************************************************

class IteratorClient
extends sqlj.runtime.ref.ResultSetIterImpl
implements sqlj.runtime.NamedIterator
{
  public IteratorClient(sqlj.runtime.profile.RTResultSet resultSet)
    throws java.sql.SQLException
  {
    super(resultSet);
    noClientNdx = findColumn("noClient");
    nomClientNdx = findColumn("nomClient");
    m_rs = (oracle.jdbc.OracleResultSet) resultSet.getJDBCResultSet();
  }
  private oracle.jdbc.OracleResultSet m_rs;
  public int noClient()
    throws java.sql.SQLException
  {
    int __sJtmp = m_rs.getInt(noClientNdx);
    if (m_rs.wasNull()) throw new sqlj.runtime.SQLNullException(); else return __sJtmp;
  }
  private int noClientNdx;
  public String nomClient()
    throws java.sql.SQLException
  {
    return m_rs.getString(nomClientNdx);
  }
  private int nomClientNdx;
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:21^64*/

    // Cration d'un objet itrateur
    IteratorClient unIteratorClient;

    // Liaison de l'nonc SELECT de l'itrateur
    /*@lineinfo:generated-code*//*@lineinfo:27^5*/

//  ************************************************************
//  #sql unIteratorClient = { SELECT noClient, nomClient
//            FROM Client WHERE noClient > 40 };
//  ************************************************************

{
  // declare temps
  oracle.jdbc.OraclePreparedStatement __sJT_st = null;
  sqlj.runtime.ref.DefaultContext __sJT_cc = sqlj.runtime.ref.DefaultContext.getDefaultContext(); if (__sJT_cc==null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext.OracleContext __sJT_ec = ((__sJT_cc.getExecutionContext()==null) ? sqlj.runtime.ExecutionContext.raiseNullExecCtx() : __sJT_cc.getExecutionContext().getOracleContext());
  try {
   String theSqlTS = "SELECT noClient, nomClient\n          FROM Client WHERE noClient > 40";
   __sJT_st = __sJT_ec.prepareOracleStatement(__sJT_cc,"0ExemplesSQLJ.ResultSetFromIterator",theSqlTS);
   // execute query
   unIteratorClient = new IteratorClient(new sqlj.runtime.ref.OraRTResultSet(__sJT_ec.oracleExecuteQuery(),__sJT_st,"0ExemplesSQLJ.ResultSetFromIterator",null));
  } finally { __sJT_ec.oracleCloseQuery(); }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:29^42*/

    // Conversion de l'itrateur en ResultSet JDBC
    ResultSet rsultatSelect = unIteratorClient.getResultSet();

    // Accs au ResultSet
    while (rsultatSelect.next ()){
      int noClient = rsultatSelect.getInt ("noClient");
      String nomClient = rsultatSelect.getString ("nomClient");
      System.out.println ("Numro du client:" + noClient);
      System.out.println ("Nom du client:" + nomClient);
    }

    // Fermer l'itrateur
    unIteratorClient.close();
  }
}/*@lineinfo:generated-code*/