package ExemplesJDBC.GererPrets;
/* Classe de contrle simple pour EnregistrerPrts
 * Interface  l'utilisateur minimaliste
 * NB Pas de vrification des conditions pralabales dans le programme client
 */
import java.sql.*;
// Le package javax contient les extensions JDBC 2 DataSource
import javax.sql.*;
import javax.naming.*;
import javax.swing.JOptionPane;
import java.util.*;

class ControleEnrPretsDataSource {
    public static void main (String args []) throws Exception {
        // Chercher la Connection  partir d'un DataSource
        InitialContext unContexte = new InitialContext();
        DataSource unDataSource = (DataSource)unContexte.lookup("jdbc/orclcleratsaCoreDS");
        
        Connection uneConnection = unDataSource.getConnection();

        String idUtilisateur = 
            JOptionPane.showInputDialog("Entrez l'identificateur de l'utilisateur: ");
        Utilisateur unUtilisateur = new Utilisateur(idUtilisateur);
        String idExemplaire = 
            JOptionPane.showInputDialog("Entrez l'identificateur de l'exemplaire:");
        Exemplaire unExemplaire = new Exemplaire(idExemplaire);
        
        // Gnrer la date du jour et l'objet PrtEnCours
        Calendar maintenant = Calendar.getInstance(); // Calendrier avec date actuelle
        java.sql.Date dateMaintenant = new java.sql.Date(maintenant.getTime().getTime());
        PrtEnCours leNouveauPrtEnCours = 
            new PrtEnCours(unUtilisateur,dateMaintenant,unExemplaire);

        // Matrialiser le PrtEnCours dans la BD
        try{
            CourtierBDPrtEnCours unCourtierBDPrtEnCours = 
                new CourtierBDPrtEnCours(uneConnection);
            unCourtierBDPrtEnCours.insrerPrtEnCours(leNouveauPrtEnCours);

            JOptionPane.showMessageDialog(null,
            "Prt de l'exemplaire " + idExemplaire +
            "  l'utilisateur " + idUtilisateur + " confirm.\nDate:" + dateMaintenant);
        }
        catch(Exception lException){
            JOptionPane.showMessageDialog(null,lException.getMessage());
            lException.printStackTrace();
        }
        finally{
            // Pas besoin de commit
            uneConnection.close();
            System.exit(0);
        }
    }
}