package ExemplesJDBC.GererPrets;
import java.sql.*;
import java.util.*;

public class CourtierBDUtilisateur{
    private Connection uneConnection;
   
    // Constructeur pour connexion passe par le crateur
    public CourtierBDUtilisateur(Connection laConnection){
        this.uneConnection = laConnection;
    }
    
    public void setConnection(Connection laConnection){
        this.uneConnection = laConnection;
    }
    
    public void chercherVariablesStatiquesDeMembre()
    // Extrait les valeurs actuelles de nbMaxPrts et dureMaxPrts
    throws Exception{
        // Initialiser les variables statiques de Membre
        PreparedStatement unEnoncSQL = uneConnection.prepareStatement
        ("SELECT nbMaxPrts, dureMaxPrts FROM MembreGnral FOR UPDATE");
        ResultSet rsultatSelect = unEnoncSQL.executeQuery();
        if (rsultatSelect.next ()){
            Membre.setNbMaxPrts(rsultatSelect.getInt ("nbMaxPrts"));
            Membre.setDureMaxPrts(rsultatSelect.getInt ("dureMaxPrts"));
            unEnoncSQL.close();
        }else{
            unEnoncSQL.close();
            throw new Exception("table MembreGnral corrompue");
        }
    }

    public Utilisateur chercherUtilisateurParIdUtilisateur(String idUtilisateur)
    // Retourne un objet Membre ou un Employ selon le cas
    throws Exception {
        // Verrouillage de l'utilisateur pour srialisabilit (Oracle mode READ COMMITTED)
        PreparedStatement unEnoncSQL = uneConnection.prepareStatement
        ("SELECT motPasse,nom,prnom,catgorieUtilisateur,tlphoneRsidence,codeMatricule,catgorieEmploy "+
        "FROM Membre m, Utilisateur u, Employ e WHERE u.idUtilisateur = ? AND "+
        "u.idUtilisateur = m.idUtilisateur (+) AND "+
        "u.idUtilisateur = e.idUtilisateur (+) FOR UPDATE");
        unEnoncSQL.setString(1,idUtilisateur);
        ResultSet rsultatSelect = unEnoncSQL.executeQuery();
        if (rsultatSelect.next ()){
            if (rsultatSelect.getString ("catgorieUtilisateur").equals("membre")){
                Membre leMembre = new Membre(
                    idUtilisateur,rsultatSelect.getString ("motPasse"),
                    rsultatSelect.getString ("nom"),rsultatSelect.getString ("prnom"),
                    rsultatSelect.getString ("catgorieUtilisateur"),
                    rsultatSelect.getString ("tlphoneRsidence"));
                unEnoncSQL.close();
                return leMembre;
            }
            else{// Pas un Membre, doit tre un Employ
                Employ lEmploy = new Employ(idUtilisateur,rsultatSelect.getString ("motPasse"),
                    rsultatSelect.getString ("nom"),rsultatSelect.getString ("prnom"),
                    rsultatSelect.getString ("catgorieUtilisateur"),
                    rsultatSelect.getString ("codeMatricule"),
                    rsultatSelect.getString ("catgorieEmploy")
                    );
                unEnoncSQL.close();
                return lEmploy;
            }
        } else {
            unEnoncSQL.close();
            throw new Exception("Utilisateur non trouv "+idUtilisateur);
        }
    }
}