package ExemplesJDBC.GererPrets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class ServletEnregistrerPretsSimple extends HttpServlet {

  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException{
    //Chercher le paramtre idUtilisateur de la FORM HTML et crer un Utilisateur
    String idUtilisateur = "";
    try { idUtilisateur = request.getParameter("idUtilisateur"); }
    catch (Exception e) { e.printStackTrace(); }
    Utilisateur unUtilisateur = new Utilisateur(idUtilisateur);
    
    //Chercher le paramtre idExemplaire de la FORM HTML et crer un Exemplaire
    String idExemplaire = "";
    try { idExemplaire = request.getParameter("idExemplaire"); }
    catch (Exception e) { e.printStackTrace(); }
    Exemplaire unExemplaire = new Exemplaire(idExemplaire);

    // Entte de la page de rponse HTML
    response.setContentType("text/html");
    OutputStreamWriter unOutputStreamWriter =
      new OutputStreamWriter(response.getOutputStream());
    PrintWriter out = new PrintWriter(unOutputStreamWriter);
    out.println("<html>");
    out.println("<head><title>Rponse de ServletEnregistrerPrets</title></head>");
    out.println("<body>");

    UsineConnection uneUsineConnection = new UsineConnection();
    Connection uneConnection = null;
    try{
      // Ouvrir une Connection (mode autocommit)
      uneConnection = uneUsineConnection.getConnection(
            "oracle.jdbc.driver.OracleDriver",
            "jdbc:oracle:thin:@localhost:1521:orcl",
            "clerat","oracle");


      // Gnrer la date du jour et l'objet PrtEnCours
      Calendar maintenant = Calendar.getInstance(); // Calendrier avec date actuelle
      java.sql.Date dateMaintenant = new java.sql.Date(maintenant.getTime().getTime());
      PrtEnCours leNouveauPrtEnCours =
        new PrtEnCours(unUtilisateur,dateMaintenant,unExemplaire);

      // Matrialiser le PrtEnCours dans la BD

      CourtierBDPrtEnCours unCourtierBDPrtEnCours =
          new CourtierBDPrtEnCours(uneConnection);
      unCourtierBDPrtEnCours.insrerPrtEnCours(leNouveauPrtEnCours);

      // Message de confirmation du prt
      out.println("Prt de l'exemplaire " + idExemplaire +
        "  l'utilisateur " + idUtilisateur + " confirm.<br>Date :" + dateMaintenant);
    }
    catch(Exception lException){
      out.println(lException.getMessage());
      lException.printStackTrace();
    }
    finally{
      try{
        // Fin de la page HTML
        out.println("</body></html>");
        out.close();
        // Pas besoin de commit
        uneConnection.close();
      }
      catch(Exception lException){
        lException.printStackTrace();
      }
    }
  }
}
