package ExemplesJDBC.GererPrets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class ServletIdentificationUtilisateur extends HttpServlet {

  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    //Chercher le paramtre idUtilisateur de la form
    String idUtilisateur = "";
    try { idUtilisateur = request.getParameter("idUtilisateur"); }
    catch (Exception e) { e.printStackTrace(); }

    // Crer un objet session si non existant
    HttpSession uneSession = request.getSession(true);

    // Entte de la page de rponse html
    response.setContentType("text/html");
    OutputStreamWriter unOutputStreamWriter = new OutputStreamWriter(response.getOutputStream());
    PrintWriter out = new PrintWriter(unOutputStreamWriter);
      out.println("<html>");
      out.println("<head><title>Rponse de ServletIdentificationUtilisateur</title></head>");
      out.println("<body>");

    UsineConnection uneUsineConnection = new UsineConnection();
    Connection uneConnection = null;

    try{
      // Ouvrir une Connection
      uneConnection = uneUsineConnection.getConnectionSansAutoCommit(
            "oracle.jdbc.driver.OracleDriver",
            "jdbc:oracle:thin:@localhost:1521:orcl",
            "clerat","oracle");
      // Dmatrialiser l'Utilisateur et ses PrtsEnCours
      Membre unMembre = null;

      // Cration du courtier et dmatrialisation de l'Utilisateur
      CourtierBDUtilisateur unCourtierBDUtilisateur =
        new CourtierBDUtilisateur(uneConnection);
      Utilisateur unUtilisateur = unCourtierBDUtilisateur.chercherUtilisateurParIdUtilisateur(idUtilisateur);

      //Cration du courtier et dmatrialisation des PrtsEnCours
      CourtierBDPrtEnCours unCourtierBDPrtEnCours =
        new CourtierBDPrtEnCours(uneConnection);
      unCourtierBDPrtEnCours.chercherLesPrtsEnCours(unUtilisateur);

      // Affichage de l'idUtilisateur et du nombre de prts
      out.println("Utilisateur :" + idUtilisateur);
      out.println(" Nombre de prts en cours :" + unUtilisateur.getNbPrtsEnCours()+"<br>");

      // Vrifier si les conditions pralables sont violes
      boolean conditionsAcceptes = false;
      if (unUtilisateur instanceof Membre){
        unCourtierBDUtilisateur.chercherVariablesStatiquesDeMembre();
        unMembre = (Membre)unUtilisateur;
        if (!unMembre.conditionsPrtAcceptes()){
          out.println("Prt refus.<br>Nb de prts :" + unMembre.getNbPrtsEnCours()+
                ". Maximum :" + Membre.getNbMaxPrts() +
                ". Nb de retards :" + unMembre.getNbRetards());
          // Librer la Connection
          uneConnection.commit();
          uneConnection.close();
        }else {conditionsAcceptes = true;}
      }else{conditionsAcceptes = true;}// Pas de contrainte pour un employ
      if(conditionsAcceptes){

        // Sauvegarder les objets du contexte de la session
        uneSession.setAttribute("uneConnection", uneConnection);
        uneSession.setAttribute("unUtilisateur", unUtilisateur);
        uneSession.setAttribute("unCourtierBDPrtEnCours", unCourtierBDPrtEnCours);


        // Construire la FORM pour saisir l'idExemplaire
        out.println("<form action = \"ServletIdentificationExemplaire\" method = \"post\">");
        out.println("<p>Entrez l'identifiant de l'exemplaire et cliquez Soumettre</p>");
        out.println("<input type = \"text\" name = \"idExemplaire\" />");
        out.println("<input type = \"submit\" value = \"Soumettre\" />");
        out.println("</form>");
      }
    }catch (Exception e) {
      out.println(e.getMessage());
      e.printStackTrace();
    }
    finally{
        out.println("</body></html>");
        out.close();
      // NB garder la connexion ouverte et ne pas terminer la transaction
    }
  }
}