package ExemplesJDBC.GererPrets.impl;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.sql.Connection;
import ExemplesJDBC.GererPrets.*;
import java.sql.Date;
import java.util.*;

public class FacadeEnrPretsSessionEJBBean implements SessionBean 
{
  private Connection uneConnection;
  private Utilisateur unUtilisateur;
  private Exemplaire unExemplaire;
  private CourtierBDPrtEnCours unCourtierBDPretEnCours;

  public void ejbCreate()throws Exception{}

  public void ejbActivate(){}

  public void ejbPassivate(){}

  public void ejbRemove(){}

  public void setSessionContext(SessionContext ctx) {
    try {
    UsineConnection uneUsineConnection = new UsineConnection();
    uneConnection = 
      uneUsineConnection.getConnectionFromDataSourceSansAutoCommit("jdbc/orclcleratCoreDS");
    }
    catch(Exception lException){
      lException.printStackTrace();
    }
  }


  public OTDUtilisateurPrets chercherOTDUtilisateurPrets(String idUtilisateur) throws Exception
  {
    // Cration du courtier et dmatrialisation de l'Utilisateur
    CourtierBDUtilisateur unCourtierBDUtilisateur = new CourtierBDUtilisateur(uneConnection);
    unUtilisateur = 
        unCourtierBDUtilisateur.chercherUtilisateurParIdUtilisateur(idUtilisateur);
        
    //Cration du courtier et dmatrialisation des PrtsEnCours
    unCourtierBDPretEnCours = new CourtierBDPrtEnCours(uneConnection);
    unCourtierBDPretEnCours.chercherLesPrtsEnCours(unUtilisateur);

    // Retourner l'objet de transfert de donnes OTDUtilisateurPrets
    if (unUtilisateur instanceof Membre){
      unCourtierBDUtilisateur.chercherVariablesStatiquesDeMembre();
      Membre unMembre = (Membre)unUtilisateur;
      return new OTDUtilisateurPrets(
                  unMembre.getCatgorie(),
                  unMembre.conditionsPrtAcceptes(),
                  unMembre.getNbPrtsEnCours(),
                  Membre.getNbMaxPrts(),
                  unMembre.getNbRetards());
    } else {
      return new OTDUtilisateurPrets(
        unUtilisateur.getCatgorie(),true,unUtilisateur.getNbPrtsEnCours(),0,0);
    }
  }

  public String getStatutExemplaire(String idExemplaire) throws Exception{
    // Chercher l'exemplaire en passant par le courtier et retourner le statut
    CourtierBDExemplaire unCourtierBDExemplaire = new CourtierBDExemplaire(uneConnection);
    unExemplaire = unCourtierBDExemplaire.chercherExemplaireParIdExemplaire(idExemplaire);
    return unExemplaire.getStatut();
  }

  public Date insererPretEnCours() throws Exception  {
    Calendar maintenant = Calendar.getInstance(); // Calendrier avec date actuelle
    java.sql.Date dateMaintenant = new java.sql.Date(maintenant.getTime().getTime());
    PrtEnCours leNouveauPrtEnCours = 
          new PrtEnCours(unUtilisateur,dateMaintenant,unExemplaire);

    // Matrialiser le PrtEnCours dans la BD
    unCourtierBDPretEnCours.insrerPrtEnCours(leNouveauPrtEnCours);
    return dateMaintenant;
  }

  public void confirmerTransaction() throws Exception  {
    uneConnection.commit();
    uneConnection.close();
  }
}